unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    ImageSel: TImage;
    ColorBox1: TColorBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button2: TButton;
    Button3: TButton;
    Shape1: TShape;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ColorBox1Select(Sender: TObject);
    procedure ImageSelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageSelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    BMSel  : TBitMap;

    _x1, _y1, _x2, _y2     : integer;
    PlumaSel               : integer;
    _x1t, _y1t, _x2t, _y2t : integer;
    BanSel                 : boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  BMSel  := TBitMap.Create;
  BanSel := false;
  Shape1.Brush.Color := clRed;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  //  Se abre la imagen o captura

  // dimensionamos el BItMap de Seleccion
  BMSel.Width  := Image1.Width;
  BMSel.Height := Image1.Height;

  BMSel.Transparent := true;
  BMSel.TransparentColor := clWhite;
  BMSel.Canvas.Pen.Color := clWhite;
  BMSel.Canvas.Rectangle(0,0,BMSel.Width, BMSel.Height);
  BMSel.Canvas.Pen.Color := clBlack;
  PlumaSel := clBlack;

  // Al ImageSel lo hacemos autoSize , en diseo
  // y tambin Transparente

  // Le asignamos el BMSel
  ImageSel.Picture.Assign(BMSel);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  BanSel := true;
  Shape1.Brush.Color := clGreen;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  BanSel := false;
  Shape1.Brush.Color := clRed;

  BMSel.Canvas.Pen.Color := clWhite;
  BMSel.Canvas.Rectangle(_x1t,_y1t,_x2t,_y2t);
  ImageSel.Picture.Assign(BMSel);
end;

procedure TForm1.ColorBox1Select(Sender: TObject);
begin
  BMSel.Canvas.Pen.Color := ColorBox1.Selected;
  PlumaSel := ColorBox1.Selected;
end;

procedure TForm1.ImageSelMouseDown(Sender: TObject;
  Button: TMouseButton;
  Shift: TShiftState;
  X, Y: Integer);
begin
  if BanSel and (Button = mbRight) then begin
    Label3.Caption := IntToStr(X)+ ' , ' + IntToStr(Y);
    _x1 := X;
    _y1 := Y;
  end;

end;

procedure TForm1.ImageSelMouseUp(Sender: TObject;
  Button: TMouseButton;
  Shift: TShiftState;
  X, Y: Integer);

var
  tt  : integer;

begin
  if BanSel and (Button = mbRight) then begin
    Label4.Caption := IntToStr(X)+ ' , ' + IntToStr(Y);
    _x2 := X;
    _y2 := Y;

    BMSel.Canvas.Pen.Color := clWhite;
    BMSel.Canvas.Rectangle(_x1t,_y1t,_x2t,_y2t);

    BMSel.Canvas.Pen.Color := PlumaSel;
    BMSel.Canvas.Rectangle(_x1,_y1,_x2,_y2);
    ImageSel.Picture.Assign(BMSel);

    _x1t := _x1;
    _y1t := _y1;

    _x2t := _x2;
    _y2t := _y2;

    // ordenar esquinas del rectangulo
    // Para que los for's de la aplicacin de filtros operen
    // correctamente
    if (_x1 > _x2) then begin
      tt  := _x1;
      _x1 := _x2;
      _x2 := tt;
    end;
    if (_y1 > _y2) then begin
      tt  := _y1;
      _y1 := _y2;
      _y2 := tt;
    end;

  end;
end;

end.
